'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _capitalize2 = require('lodash/capitalize');

var _capitalize3 = _interopRequireDefault(_capitalize2);

var _merge2 = require('lodash/merge');

var _merge3 = _interopRequireDefault(_merge2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _loreUtils = require('lore-utils');

var _loreReactForms = require('lore-react-forms');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _createReactClass2.default)({
  displayName: 'Update.Optimistic',

  propTypes: {
    data: _propTypes2.default.object,
    validators: _propTypes2.default.object,
    onChange: _propTypes2.default.func,
    onSubmit: _propTypes2.default.func,
    callbacks: _propTypes2.default.object,
    schema: _propTypes2.default.object.isRequired,
    fieldMap: _propTypes2.default.object.isRequired,
    actionMap: _propTypes2.default.object.isRequired,
    config: _propTypes2.default.object.isRequired,
    modelName: _propTypes2.default.string.isRequired
  },

  getInitialState: function getInitialState() {
    var _props = this.props,
        model = _props.model,
        data = _props.data;


    return {
      data: (0, _merge3.default)({}, model.data, data)
    };
  },

  onSubmit: function onSubmit(data) {
    var _props2 = this.props,
        modelName = _props2.modelName,
        model = _props2.model;

    lore.actions[modelName].update(model, data);
  },

  onChange: function onChange(name, value) {
    var nextData = (0, _merge3.default)({}, this.state.data);
    nextData[name] = value;
    this.setState({
      data: nextData
    });
  },

  getValidators: function getValidators(data) {
    var validators = this.props.validators;

    return (0, _loreUtils.result)(validators || {}, data);
  },

  render: function render() {
    var modelName = this.props.modelName;
    var _props3 = this.props,
        schema = _props3.schema,
        fieldMap = _props3.fieldMap,
        actionMap = _props3.actionMap,
        config = _props3.config;
    var data = this.state.data;

    var validators = this.getValidators(data);

    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        'div',
        { style: { padding: '20px', fontSize: '20px', fontWeight: '500' } },
        'Update ' + (0, _capitalize3.default)(modelName)
      ),
      _react2.default.createElement(_loreReactForms.SchemaForm, {
        data: data,
        validators: validators,
        onChange: this.onChange,
        onSubmit: this.onSubmit,
        callbacks: {
          onSubmit: this.onSubmit
        },
        schema: schema,
        fieldMap: fieldMap,
        actionMap: actionMap,
        config: (0, _merge3.default)({
          fields: {},
          actions: []
        }, config)
      })
    );
  }

});